'use strict';

Object.defineProperty(exports, '__esModule', {
				value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _reactPropertyEditor = require('react-property-editor');

var _reactPropertyEditor2 = _interopRequireDefault(_reactPropertyEditor);

var _utilToEmptyProps = require('../util/toEmptyProps');

var _utilToEmptyProps2 = _interopRequireDefault(_utilToEmptyProps);

var _utilContainerMetadata = require('../util/containerMetadata');

var BOX_EMPTY_STYLE = {
				top: undefined,
				left: undefined,
				width: undefined,
				height: undefined,
				zIndex: undefined,
				transform: {
								tx: undefined, ty: undefined, //translate in px
								sx: undefined, sy: undefined, //scale
								rz: undefined, //rotation in radian
								ox: undefined, oy: undefined //transform origin
				}
};

var CONTAINER_EMPTY_STYLE = {
				top: undefined,
				left: undefined,
				width: undefined,
				height: undefined,
				position: 'relative'
};
var EMPTY_BINDING_PROPS = {
				path: undefined,
				mode: undefined,
				converter: undefined,
				converterArgs: undefined
};

var ObjectPropertyGrid = (function (_React$Component) {
				_inherits(ObjectPropertyGrid, _React$Component);

				function ObjectPropertyGrid() {
								_classCallCheck(this, ObjectPropertyGrid);

								_get(Object.getPrototypeOf(ObjectPropertyGrid.prototype), 'constructor', this).apply(this, arguments);
				}

				_createClass(ObjectPropertyGrid, [{
								key: 'widgetPropsChanged',
								value: function widgetPropsChanged(updatedValue) {
												var current = this.props.current.node;
												var updated = current.set({ "props": updatedValue.props, "bindings": updatedValue.binding });
												this.props.currentChanged(updated);
								}
				}, {
								key: 'commonPropsChanged',
								value: function commonPropsChanged(updatedValue) {
												updatedValue = updatedValue.props;
												var current = this.props.current.node;
												var updated;
												if (current.name !== updatedValue.name) {
																updated = current.set("name", updatedValue.name);
												} else {
																updated = current.set("style", updatedValue.style);
												}
												this.props.currentChanged(updated);
								}
				}, {
								key: 'render',
								value: function render() {
												var currentNode = this.props.current.node;
												var elementName = currentNode.elementName;

												var isContainer = _lodash2['default'].contains(_utilContainerMetadata.ContainerKeys, elementName);

												var metaData = isContainer ? _utilContainerMetadata.ContainerMetadata[elementName].metaData : this.props.widgets[elementName] && this.props.widgets[elementName].metaData;

												if (elementName === "ObjectSchema") metaData.settings.fields["context"].fields["styles"].settings = { widgets: this.props.widgets };
												//only to remove freezer js -> thats is needed for react-json to refresh state when changing instance nodes
												//TODO: better solution for comunication between this component and react-json
												var plainNode = currentNode.toJS();

												//bindings
												var bindings = _lodash2['default'].reduce(plainNode.bindings, function (memo, item, key) {
																if (item !== undefined) memo[key] = _lodash2['default'].extend(_lodash2['default'].clone(EMPTY_BINDING_PROPS), item);
																return memo;
												}, {});

												//props
												var settings = _lodash2['default'].extend(metaData && metaData.settings || {}, { useBinding: true });
												var props = _lodash2['default'].merge((0, _utilToEmptyProps2['default'])(settings), plainNode.props);

												var commonProps = { name: currentNode.name };
												if (elementName !== "ObjectSchema") commonProps["style"] = _lodash2['default'].merge(_lodash2['default'].cloneDeep(isContainer ? CONTAINER_EMPTY_STYLE : BOX_EMPTY_STYLE), currentNode.style);

												return _react2['default'].createElement(
																'div',
																null,
																_react2['default'].createElement(_reactPropertyEditor2['default'], { value: { props: commonProps, binding: bindings }, onChange: this.commonPropsChanged.bind(this) }),
																_react2['default'].createElement(_reactPropertyEditor2['default'], { value: { props: props, binding: bindings }, settings: settings,
																				onChange: this.widgetPropsChanged.bind(this) })
												);
								}
				}]);

				return ObjectPropertyGrid;
})(_react2['default'].Component);

exports['default'] = ObjectPropertyGrid;
;
module.exports = exports['default'];