'use strict';

Object.defineProperty(exports, '__esModule', {
	value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactBinding = require('react-binding');

var _reactBinding2 = _interopRequireDefault(_reactBinding);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _reactDndHtml5Backend = require('react-dnd-html5-backend');

var _reactDndHtml5Backend2 = _interopRequireDefault(_reactDndHtml5Backend);

var _reactDnd = require('react-dnd');

var _transhand = require('transhand');

var _workplaceContainer = require('./../workplace/Container');

var _workplaceContainer2 = _interopRequireDefault(_workplaceContainer);

var _utilBackgroundStyle = require('../util/backgroundStyle');

var _utilBackgroundStyle2 = _interopRequireDefault(_utilBackgroundStyle);

var _workplaceRichTextEditor = require('../workplace/RichTextEditor');

var _workplaceRichTextEditor2 = _interopRequireDefault(_workplaceRichTextEditor);

var defaultTransform = {
	tx: 0, ty: 0, //translate in px
	sx: 1, sy: 1, //scale
	rz: 0, //rotation in radian
	ox: 0.5, oy: 0.5 //transform origin
};

var Workplace = (function (_React$Component) {
	_inherits(Workplace, _React$Component);

	function Workplace(props) {
		_classCallCheck(this, Workplace);

		_get(Object.getPrototypeOf(Workplace.prototype), 'constructor', this).call(this, props);
		this.state = { data: _lodash2['default'].cloneDeep(this.props.schema.props.defaultData) || {} };
	}

	_createClass(Workplace, [{
		key: 'getChildContext',
		value: function getChildContext() {
			return { snapGrid: this.props.snapGrid };
		}
	}, {
		key: 'handleChange',
		value: function handleChange(change) {
			var currentNode = this.props.current.node;
			if (currentNode == undefined) return;

			var style = currentNode.style;
			if (style === undefined) return;

			//resolution strategy -> defaultTransform -> style.transform -> change
			var transform = _lodash2['default'].merge(_lodash2['default'].merge(_lodash2['default'].clone(defaultTransform), style.transform), change);

			//apply to current DOM node
			//this.state.currentNode.style.transform = this.generateCssTransform(transform);
			//this.state.currentNode.style.transformOrigin = `${transform.ox*100}% ${transform.oy*100}%`;

			var updated = currentNode.set('style', _lodash2['default'].extend(_lodash2['default'].clone(style), { 'transform': transform }));
			this.props.currentChanged(updated);
		}
	}, {
		key: 'componentWillReceiveProps',
		value: function componentWillReceiveProps(newProps) {
			var defaultData = this.props.schema.props && this.props.schema.props.defaultData;
			var newDefautData = newProps.schema.props && newProps.schema.props.defaultData;

			if (defaultData !== newDefautData) {
				this.setState({ data: _lodash2['default'].cloneDeep(newDefautData) });
			}
		}
	}, {
		key: 'currentChanged',
		value: function currentChanged(node, path, domEl) {
			if (this.props.currentChanged !== undefined) this.props.currentChanged(node, path);
			this.setState({
				currentDOMNode: domEl
			});
		}
	}, {
		key: 'render',
		value: function render() {
			var handleClick = (function () {
				if (this.props.currentChanged !== undefined) this.props.currentChanged(this.props.schema, this.props.path);
			}).bind(this);

			var dataContext = _reactBinding2['default'].bindToState(this, 'data');

			var style = this.props.current.node.style || {};
			var transform = _lodash2['default'].merge(_lodash2['default'].clone(defaultTransform), style.transform);

			var ctx = this.props.schema.props && this.props.schema.props.context || {};
			var customStyles = ctx['styles'] || {};
			var code = ctx['code'] && ctx['code'].code;
			var customCode = !!code ? new Function(code)() : undefined;

			//append shared code to data context
			dataContext.customCode = customCode;

			var context = {
				styles: customStyles,
				customCode: customCode
			};

			var bg = this.props.schema.props && this.props.schema.props.background || {};
			var bgStyle = (0, _utilBackgroundStyle2['default'])(bg);

			bgStyle.position = 'absolute';
			bgStyle.width = '100%';
			bgStyle.height = '100%';
			bgStyle.zIndex = -1;

			var component = _react2['default'].createElement(_workplaceContainer2['default'], {
				containers: this.props.schema.containers,
				boxes: this.props.schema.boxes,
				currentChanged: this.currentChanged.bind(this),
				current: this.props.current,
				path: 'schema',
				handleClick: handleClick,
				isRoot: true,
				node: this.props.schema,
				dataBinder: dataContext,
				ctx: context,
				widgets: this.props.widgets,
				widgetRenderer: this.props.widgetRenderer
			});

			return _react2['default'].createElement(
				'div',
				{ className: 'cWorkplace' },
				_react2['default'].createElement('div', { style: bgStyle }),
				component,
				this.state.currentDOMNode !== undefined ? _react2['default'].createElement(_transhand.CSSTranshand, { transform: transform, deTarget: this.state.currentDOMNode,
					onChange: this.handleChange.bind(this) }) : null
			);
		}
	}]);

	return Workplace;
})(_react2['default'].Component);

;
Workplace.childContextTypes = { snapGrid: _react2['default'].PropTypes.arrayOf(_react2['default'].PropTypes.number) };
exports['default'] = (0, _reactDnd.DragDropContext)(_reactDndHtml5Backend2['default'])(Workplace);
module.exports = exports['default'];