'use strict';

Object.defineProperty(exports, '__esModule', {
	value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDnd = require('react-dnd');

var _utilItemTypesJs = require('../util/ItemTypes.js');

var _utilItemTypesJs2 = _interopRequireDefault(_utilItemTypesJs);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _transhand = require('transhand');

var _ResizeContainerJs = require('./ResizeContainer.js');

var _ResizeContainerJs2 = _interopRequireDefault(_ResizeContainerJs);

var _workplaceRichTextEditor = require('../workplace/RichTextEditor');

var _workplaceRichTextEditor2 = _interopRequireDefault(_workplaceRichTextEditor);

/**
 * Implements the drag source contract.
 */
var source = {
	beginDrag: function beginDrag(props, monitor, component) {
		return {
			//effectAllowed: DropEffects.MOVE,
			item: component.props
		};
	}
};

/**
 * Specifies the props to inject into your component.
 */
function collect(connect, monitor) {
	return {
		connectDragSource: connect.dragSource(),
		isDragging: monitor.isDragging()
	};
}
var propTypes = {
	//item: PropTypes.string.isRequired,

	// Injected by React DnD:
	isDragging: _react.PropTypes.bool.isRequired,
	connectDragSource: _react.PropTypes.func.isRequired
};

var Box = (function (_React$Component) {
	_inherits(Box, _React$Component);

	function Box() {
		_classCallCheck(this, Box);

		_get(Object.getPrototypeOf(Box.prototype), 'constructor', this).apply(this, arguments);
	}

	_createClass(Box, [{
		key: 'handleDoubleClick',
		value: function handleDoubleClick(e) {
			e.stopPropagation();
			if (this.props.currentChanged !== undefined) this.props.currentChanged(this.props.node, this.props.path, _react2['default'].findDOMNode(this));
		}
	}, {
		key: 'handleClick',
		value: function handleClick(e) {
			e.stopPropagation();
			if (this.props.currentChanged !== undefined) this.props.currentChanged(this.props.node, this.props.path);
		}
	}, {
		key: 'shouldComponentUpdate',
		value: function shouldComponentUpdate(nextProps) {

			// The comparison is fast, and we won't render the component if
			// it does not need it. This is a huge gain in performance.
			var box = this.props.node;
			var update = this.props.node !== nextProps.node || this.props.selected != nextProps.selected;
			//console.log(nextProps.node.name + ' : ' + update);
			if (update) return update;

			var propsStyles = this.props.ctx.styles;
			var nextPropsStyles = nextProps.ctx.styles;
			update = (propsStyles && propsStyles[box.elementName]) !== (nextPropsStyles && nextPropsStyles[box.elementName]);

			return update;
		}
	}, {
		key: 'generateCssTransform',
		value: function generateCssTransform(transform) {
			var cssTransform = '';

			if (transform.tx !== undefined) cssTransform += ' translateX(' + transform.tx + 'px)';
			if (transform.ty !== undefined) cssTransform += ' translateY(' + transform.ty + 'px)';
			if (transform.rz !== undefined) cssTransform += ' rotate(' + transform.rz + 'rad)';
			if (transform.sx !== undefined) cssTransform += ' scaleX(' + transform.sx + ')';
			if (transform.sy !== undefined) cssTransform += ' scaleY(' + transform.sy + ')';

			return cssTransform;
		}
	}, {
		key: 'render',
		value: function render() {
			//console.log(this.props.path);
			//prepare styles
			var classes = (0, _classnames2['default'])({
				'box': true,
				'selected': this.props.selected
			});

			var box = this.props.node.toJS();
			var ctx = this.props.ctx || {};
			var customStyle = ctx["styles"] && ctx["styles"][box.elementName];
			//var intlData = ctx["intlData"];

			var widgets = this.props.widgets;
			//propagete width and height to widget props
			if (!box.props.width && !!box.style.width) box.props.width = box.style.width;
			if (!box.props.height && !!box.style.height) box.props.height = box.style.height;

			var WidgetRenderer = this.props.widgetRenderer;

			var boxComponent = WidgetRenderer !== undefined ? _react2['default'].createElement(WidgetRenderer, { widget: widgets[box.elementName], node: box, dataBinder: this.props.dataBinder,
				customStyle: customStyle, customCode: ctx['customCode'], designer: true }) : _react2['default'].createElement(
				'div',
				null,
				'No widget renderer provided'
			);
			var _props = this.props;
			var isDragging = _props.isDragging;
			var connectDragSource = _props.connectDragSource;
			var item = _props.item;

			//var styles = _.omit(box.style,['width','height']);
			var styles = _lodash2['default'].extend({ position: this.props.position }, box.style);

			if (box.style.transform !== undefined) styles['transform'] = this.generateCssTransform(box.style.transform);

			var isInlineEdit = this.props.selected && box.elementName === "Core.RichTextContent";
			var inlineEditor = _react2['default'].createElement(_workplaceRichTextEditor2['default'], { font: box.props.font, current: this.props.node,
				currentChanged: this.props.currentChanged, content: box.props.content });

			return connectDragSource(_react2['default'].createElement(
				'div',
				{ style: styles, className: classes, onClick: this.handleClick.bind(this) },
				_react2['default'].createElement(
					_ResizeContainerJs2['default'],
					{ node: this.props.node, currentChanged: this.props.currentChanged },
					isInlineEdit ? inlineEditor : _react2['default'].createElement(
						'div',
						{ onDoubleClick: this.handleDoubleClick.bind(this) },
						boxComponent
					)
				)
			));
		}
	}]);

	return Box;
})(_react2['default'].Component);

;

Box.propTypes = propTypes;

// Export the wrapped component:
exports['default'] = (0, _reactDnd.DragSource)(_utilItemTypesJs2['default'].BOX, source, collect)(Box);
module.exports = exports['default'];