'use strict';

Object.defineProperty(exports, '__esModule', {
	value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _utilItemTypesJs = require('../util/ItemTypes.js');

var _utilItemTypesJs2 = _interopRequireDefault(_utilItemTypesJs);

var _reactDnd = require('react-dnd');

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Box = require('./Box');

var _Box2 = _interopRequireDefault(_Box);

//import Row from './Row';

var _ResizableHandleJs = require('./ResizableHandle.js');

var _ResizableHandleJs2 = _interopRequireDefault(_ResizableHandleJs);

var _utilBackgroundStyle = require('../util/backgroundStyle');

var _utilBackgroundStyle2 = _interopRequireDefault(_utilBackgroundStyle);

var _utilBorder = require('../util/border');

var _utilBorder2 = _interopRequireDefault(_utilBorder);

var HANDLE_OFFSET = 8;

var snapToGrid = function snapToGrid(grid, deltaX, deltaY) {
	var x = Math.round(deltaX / grid[0]) * grid[0];
	var y = Math.round(deltaY / grid[1]) * grid[1];
	return [x, y];
};

var target = {
	drop: function drop(props, monitor, component) {
		if (monitor.didDrop()) {
			// If you want, you can check whether some nested
			// target already handled drop
			return;
		}
		//props.onDrop(monitor.getItem());

		var item = monitor.getItem().item;
		//console.log(item);

		var delta = monitor.getDifferenceFromInitialOffset();
		//console.log(delta);
		if (!!!delta) return;

		if (monitor.getItemType() === _utilItemTypesJs2['default'].BOX) {
			var left = Math.round(isNaN(item.left) ? 0 : parseInt(item.left, 10) + delta.x);
			var top = Math.round(isNaN(item.top) ? 0 : parseInt(item.top, 10) + delta.y);

			component.moveBox(item.index, left, top);
		}

		if (monitor.getItemType() === _utilItemTypesJs2['default'].RESIZABLE_HANDLE) {
			var left = Math.round(delta.x < 0 ? delta.x + HANDLE_OFFSET : delta.x - HANDLE_OFFSET);
			var top = Math.round(delta.y < 0 ? delta.y + HANDLE_OFFSET : delta.y - HANDLE_OFFSET);
			component.resizeContainer(item.parent, left, top);
		}
	}
};

var Container = (function (_React$Component) {
	_inherits(Container, _React$Component);

	function Container() {
		_classCallCheck(this, Container);

		_get(Object.getPrototypeOf(Container.prototype), 'constructor', this).apply(this, arguments);
	}

	_createClass(Container, [{
		key: 'shouldComponentUpdate',
		value: function shouldComponentUpdate(nextProps, nextState) {

			//return true;

			// The comparison is fast, and we won't render the component if
			// it does not need it. This is a huge gain in performance.
			//var box = this.props.node;
			var update = this.props.node !== nextProps.node || (this.props.current && this.props.current.path) != (nextProps.current && nextProps.current.path);

			//if (update)	console.log(nextProps.node.name + ' : ' + update);
			if (update) return update;

			//var propsStyles = this.props.ctx.styles;
			//var nextPropsStyles = nextProps.ctx.styles;
			//update = (propsStyles && propsStyles[box.elementName]) !== (nextPropsStyles && nextPropsStyles[box.elementName]);

			return update;
		}

		// componentWillReceiveProps(nextProps) {
		// 	var current = this.props.node;
		// 	var updatedCurrent = nextProps.node;
		// 	console.log(nextProps.node.name);
		// 	if (!updatedCurrent.$selected) return;
		//	
		//	
		//	
		// 	var parent = updatedCurrent.__.parents;
		// 	var parentNode = parent.length !== 0 ? parent[0].__.parents[0] : undefined;
		// 	this.setState({
		// 			current: {
		// 				node: updatedCurrent,
		// 				parentNode: parentNode
		// 			}
		// 		}
		// 	);
		//}

	}, {
		key: 'moveBox',
		value: function moveBox(index, left, top) {
			var boxes = this.props.boxes;
			if (boxes === undefined) return;
			var box = boxes[index];
			if (box === undefined) return;

			var deltas = snapToGrid(this.context.snapGrid, left, top);
			var updated = box.set({ 'style': _lodash2['default'].merge(_lodash2['default'].clone(box.style), { 'left': deltas[0], 'top': deltas[1] }) });
			//var updated = box.set({'style': {'top': top, 'left': left,'height':box.style.height,'width':box.style.width}});
			this.props.currentChanged(updated);
		}
	}, {
		key: 'resizeContainer',
		value: function resizeContainer(container, deltaWidth, deltaHeight) {
			if (container === undefined) return;

			//TODO: use merge instead of clone
			var style = _lodash2['default'].clone(container.style);
			var newWidth = (style.width || 0) + deltaWidth;
			if (newWidth < 0) return;
			var newHeight = (style.height || 0) + deltaHeight;
			if (newHeight < 0) return;

			var deltas = snapToGrid(this.context.snapGrid, newWidth, newHeight);
			style.width = deltas[0];
			style.height = deltas[1];

			//var newStyle = {'style':{'top':container.top,'left':container.left,'width':width,'height':height, 'position':container.position}};
			var updated = container.set({ 'style': style });
			this.props.currentChanged(updated);
			//currentChanged(updated);
		}
	}, {
		key: 'handleClick',
		value: function handleClick(e) {
			e.stopPropagation();
			if (this.props.handleClick !== undefined) this.props.handleClick();
		}
	}, {
		key: 'render',
		value: function render() {
			var _props = this.props;
			var elementName = _props.elementName;
			var ctx = _props.ctx;
			var widgets = _props.widgets;
			var node = _props.node;
			var parent = _props.parent;
			var dataBinder = _props.dataBinder;
			var _props2 = this.props;
			var canDrop = _props2.canDrop;
			var isOver = _props2.isOver;
			var connectDropTarget = _props2.connectDropTarget;

			var containers = this.props.containers || [];
			var boxes = this.props.boxes || [];

			//styles
			var classes = (0, _classnames2['default'])({
				'con': true,
				'selected': this.props.selected,
				'parentSelected': this.props.parentSelected,
				'root': this.props.isRoot
			});

			var styles = {
				left: this.props.left,
				top: this.props.top,
				height: this.props.height,
				width: this.props.width,
				position: this.props.position || 'relative'
			};

			var nodeProps = node.props;
			var nodeBindings = node.bindings || {};

			//apply custom styles
			var customStyle = ctx["styles"] && ctx["styles"][elementName];
			if (customStyle !== undefined) nodeProps = _lodash2['default'].merge(_lodash2['default'].cloneDeep(customStyle), nodeProps);

			//apply node props
			if (this.props.dataBinder !== undefined) nodeProps = this.props.widgetRenderer.bindProps(_lodash2['default'].cloneDeep(nodeProps), nodeBindings.bindings, this.props.dataBinder, true);

			var containerComponent = widgets[elementName] || 'div';

			return connectDropTarget(_react2['default'].createElement(
				'div',
				{ className: classes, style: styles, onClick: this.handleClick.bind(this) },
				_react2['default'].createElement(
					'div',
					null,
					containers.length !== 0 ? _react2['default'].createElement(containerComponent, nodeProps, containers.map(function (container, index) {

						var selected = container === this.props.current.node;
						var parentSelected = false; //container === this.props.current.parentNode;
						var key = container.name + index;

						var handleClick = (function () {
							if (this.props.currentChanged !== undefined) this.props.currentChanged(container, this.props.path);
						}).bind(this);

						var left = container.style.left === undefined ? 0 : parseInt(container.style.left, 10);
						var top = container.style.top === undefined ? 0 : parseInt(container.style.top, 10);

						//je potreba merge
						var childProps = _lodash2['default'].cloneDeep(container.props) || {};
						var childBindings = container.bindings || {};

						//apply custom styles
						var childCustomStyle = ctx["styles"] && ctx["styles"][container.elementName];
						if (childCustomStyle !== undefined) childProps = _lodash2['default'].merge(_lodash2['default'].cloneDeep(childCustomStyle), childProps);

						//apply node props
						if (dataBinder !== undefined) childProps = this.props.widgetRenderer.bindProps(childProps, childBindings.bindings, dataBinder, true);

						//propagete width and height to child container props
						if (!childProps.width && !!container.style.width) childProps.width = container.style.width;
						if (!childProps.height && !!container.style.height) childProps.height = container.style.height;

						var childComponent = widgets[container.elementName] || 'div';
						var path = this.props.path + '.containers[' + index + ']';
						return _react2['default'].createElement(childComponent, _lodash2['default'].extend(childProps, { child: true, key: key }), _react2['default'].createElement(WrappedContainer, { elementName: container.elementName,
							index: index,
							left: left,
							top: top,
							height: container.style.height,
							width: container.style.width,
							position: container.style.position || 'relative',
							boxes: container.boxes,
							containers: container.containers,
							node: container,
							path: path,
							parent: this.props.parent,
							currentChanged: this.props.currentChanged,
							current: this.props.current,
							handleClick: handleClick,
							parentSelected: parentSelected,
							selected: selected,
							dataBinder: this.props.dataBinder,
							ctx: this.props.ctx,
							widgets: widgets,
							widgetRenderer: this.props.widgetRenderer
						}));
					}, this)) : null,
					boxes.map(function (box, index) {

						var selected = box === this.props.current.node;
						var key = box.name + index;

						var left = box.style.left === undefined ? 0 : parseInt(box.style.left, 10);
						var top = box.style.top === undefined ? 0 : parseInt(box.style.top, 10);

						var path = this.props.path + '.boxes[' + index + ']';
						return _react2['default'].createElement(_Box2['default'], { key: key,
							index: index,
							left: left,
							top: top,
							path: path,
							position: elementName === "Cell" ? 'relative' : 'absolute',
							selected: selected,
							hideSourceOnDrag: this.props.hideSourceOnDrag,
							currentChanged: this.props.currentChanged,
							node: box, dataBinder: this.props.dataBinder,
							ctx: this.props.ctx,
							widgets: this.props.widgets,
							widgetRenderer: this.props.widgetRenderer
						});
					}, this)
				),
				this.props.isRoot || this.props.width === undefined || this.props.height === undefined ? null : _react2['default'].createElement(_ResizableHandleJs2['default'], { parent: this.props.node })
			));
		}
	}]);

	return Container;
})(_react2['default'].Component);

Container.contextTypes = {
	snapGrid: _react2['default'].PropTypes.arrayOf(_react2['default'].PropTypes.number)
};

var collect = function collect(connect, monitor) {
	return {
		connectDropTarget: connect.dropTarget(),
		isOver: monitor.isOver(),
		canDrop: monitor.canDrop()
	};
};
var WrappedContainer = (0, _reactDnd.DropTarget)([_utilItemTypesJs2['default'].RESIZABLE_HANDLE, _utilItemTypesJs2['default'].BOX], target, collect)(Container);
// Export the wrapped component:
exports['default'] = WrappedContainer;

//module.exports = Container;
module.exports = exports['default'];