'use strict';

Object.defineProperty(exports, '__esModule', {
	value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _draftJs = require('draft-js');

var _reactOverlays = require('react-overlays');

var _RichTextEditorToolbox = require('./RichTextEditorToolbox');

var _RichTextEditorToolbox2 = _interopRequireDefault(_RichTextEditorToolbox);

var hasCommandModifier = _draftJs.KeyBindingUtil.hasCommandModifier;

var styleFont = function styleFont(style, fontProps) {

	if (style === undefined) style = {};
	if (fontProps === undefined) return style;

	style = _lodash2['default'].extend(style, fontProps) || {};
	if (fontProps.color) style['color'] = fontProps.color.color;
	if (fontProps.bold) style['fontWeight'] = 'bold';
	if (fontProps.italic) style['fontStyle'] = 'italic';
	if (fontProps.underline) style['borderBottom'] = '1px dashed #999';
	return style;
};

var myKeyBindingFn = function myKeyBindingFn(e) {
	if (e.keyCode === 83 /* `S` key */ && hasCommandModifier(e)) {
		return 'myeditor-save';
	}
	return (0, _draftJs.getDefaultKeyBinding)(e);
};

var RichEditor = (function (_React$Component) {
	_inherits(RichEditor, _React$Component);

	function RichEditor(props) {
		var _this = this;

		_classCallCheck(this, RichEditor);

		_get(Object.getPrototypeOf(RichEditor.prototype), 'constructor', this).call(this, props);
		this.state = {
			editorState: _draftJs.EditorState.createEmpty(),
			showBlockStyleControls: false,
			showInlineStyleControls: false,
			show: false
		};

		this.focus = function () {
			return _this.refs.editor.focus();
		};
		this.saveChanges = _lodash2['default'].debounce(this.saveChanges, 1000);
		this.onChange = function (editorState) {
			_this.setState({ editorState: editorState });_this.saveChanges();
		};

		this.handleKeyCommand = function (command) {
			return _this._handleKeyCommand(command);
		};
		this.toggleBlockType = function (type) {
			return _this._toggleBlockType(type);
		};
		this.toggleInlineStyle = function (style) {
			return _this._toggleInlineStyle(style);
		};
	}

	// Custom overrides for "code" style.

	_createClass(RichEditor, [{
		key: 'componentWillMount',
		value: function componentWillMount() {
			this.setState({ editorState: this.props.content !== undefined ? _draftJs.EditorState.createWithContent(_draftJs.ContentState.createFromBlockArray((0, _draftJs.convertFromRaw)(this.props.content))) : _draftJs.EditorState.createWithContent(_draftJs.ContentState.createFromText('Type your content')) });
		}
	}, {
		key: 'toolboxToggle',
		value: function toolboxToggle() {
			var show = this.state.show;
			var placements = ['left', 'top', 'right', 'bottom'];
			var placement = this.state.placement;

			placement = 'top'; //placements[placements.indexOf(placement)];

			if (!show) {
				show = true;
				placement = 'top'; //placements[0];
			} else if (!placement) {
					show = false;
				}

			return this.setState({ show: show, placement: placement });
		}
	}, {
		key: 'saveChanges',
		value: function saveChanges(e) {
			var editorState = this.state.editorState;

			var current = this.props.current;
			var updated = current.set("props", _lodash2['default'].extend({
				content: (0, _draftJs.convertToRaw)(editorState.getCurrentContent())
			}, _lodash2['default'].omit(current.props, 'content')));

			this.props.currentChanged(updated);
		}

		//componentWillUnmount(){
		//	var content =this.state.editorState.getCurrentContent();
		//	var raw = convertToRaw(content);
		//	var updated = this.props.current.set({"props": {"content":raw}});
		//	this.props.currentChanged(updated);
		//}
	}, {
		key: '_handleKeyCommand',
		value: function _handleKeyCommand(command) {
			var editorState = this.state.editorState;

			if (command === 'myeditor-save') {
				var current = this.props.current;
				var updated = current.set("props", _lodash2['default'].extend({
					content: (0, _draftJs.convertToRaw)(editorState.getCurrentContent())
				}, _lodash2['default'].omit(current.props, 'content')));

				this.props.currentChanged(updated);
				return true;
			} else {
				var newState = _draftJs.RichUtils.handleKeyCommand(editorState, command);
				if (newState) {
					this.onChange(newState);
					return true;
				}
			}
			return false;
		}
	}, {
		key: '_toggleBlockType',
		value: function _toggleBlockType(blockType) {
			this.onChange(_draftJs.RichUtils.toggleBlockType(this.state.editorState, blockType));
		}
	}, {
		key: '_toggleInlineStyle',
		value: function _toggleInlineStyle(inlineStyle) {
			this.onChange(_draftJs.RichUtils.toggleInlineStyle(this.state.editorState, inlineStyle));
		}
	}, {
		key: 'render',
		value: function render() {
			var _this2 = this;

			var editorState = this.state.editorState;

			// If the user changes block type before entering any text, we can
			// either style the placeholder or hide it. Let's just hide it now.
			var className = 'RichEditor-editor';
			var contentState = editorState.getCurrentContent();
			if (!contentState.hasText()) {
				if (contentState.getBlockMap().first().getType() !== 'unstyled') {
					className += ' RichEditor-hidePlaceholder';
				}
			}
			var style = this.props.style || {};

			styleFont(style, this.props.font);

			return _react2['default'].createElement(
				'div',
				null,
				_react2['default'].createElement(
					'div',
					{ className: 'RichEditor-root' },
					_react2['default'].createElement(
						'div',
						{ style: style, className: className, onClick: this.focus, onMouseEnter: this.toolboxToggle.bind(this), onMouseLeave: this.toolboxToggle.bind(this) },
						_react2['default'].createElement(_draftJs.Editor, {
							blockStyleFn: getBlockStyle,
							customStyleMap: styleMap,
							editorState: editorState,
							handleKeyCommand: this.handleKeyCommand.bind(this),
							keyBindingFn: myKeyBindingFn,
							onChange: this.onChange,
							placeholder: 'Tell a story...',
							ref: 'editor',
							spellCheck: true
						})
					)
				),
				_react2['default'].createElement(
					_reactOverlays.Overlay,
					{
						show: this.state.show,
						onHide: function () {
							return _this2.setState({ show: false });
						},
						placement: this.state.placement,
						container: this,
						target: function (props) {
							return _reactDom2['default'].findDOMNode(_this2.refs.editor);
						}
					},
					_react2['default'].createElement(
						_RichTextEditorToolbox2['default'],
						null,
						_react2['default'].createElement(InlineStyleControls, {
							editorState: editorState,
							onToggle: this.toggleInlineStyle
						})
					)
				)
			);
		}
	}]);

	return RichEditor;
})(_react2['default'].Component);

exports['default'] = RichEditor;
var styleMap = {
	CODE: {
		backgroundColor: 'rgba(0, 0, 0, 0.05)',
		fontFamily: '"Inconsolata", "Menlo", "Consolas", monospace',
		fontSize: 16,
		padding: 2
	}
};

function getBlockStyle(block) {
	switch (block.getType()) {
		case 'blockquote':
			return 'RichEditor-blockquote';
		default:
			return null;
	}
}

var StyleButton = (function (_React$Component2) {
	_inherits(StyleButton, _React$Component2);

	function StyleButton() {
		var _this3 = this;

		_classCallCheck(this, StyleButton);

		_get(Object.getPrototypeOf(StyleButton.prototype), 'constructor', this).call(this);
		this.onToggle = function (e) {
			e.preventDefault();
			_this3.props.onToggle(_this3.props.style);
		};
	}

	_createClass(StyleButton, [{
		key: 'render',
		value: function render() {
			var className = 'RichEditor-styleButton';
			if (this.props.active) {
				className += ' RichEditor-activeButton';
			}

			return _react2['default'].createElement(
				'span',
				{ className: className, onMouseDown: this.onToggle },
				this.props.label
			);
		}
	}]);

	return StyleButton;
})(_react2['default'].Component);

var BLOCK_TYPES = [{ label: 'H1', style: 'header-one' }, { label: 'H2', style: 'header-two' }, { label: 'Blockquote', style: 'blockquote' }, { label: 'UL', style: 'unordered-list-item' }, { label: 'OL', style: 'ordered-list-item' }, { label: 'Code Block', style: 'code-block' }];

var BlockStyleControls = function BlockStyleControls(props) {
	var editorState = props.editorState;

	var selection = editorState.getSelection();
	var blockType = editorState.getCurrentContent().getBlockForKey(selection.getStartKey()).getType();

	return _react2['default'].createElement(
		'div',
		{ className: 'RichEditor-controls' },
		BLOCK_TYPES.map(function (type) {
			return _react2['default'].createElement(StyleButton, {
				key: type.label,
				active: type.style === blockType,
				label: type.label,
				onToggle: props.onToggle,
				style: type.style
			});
		})
	);
};

var INLINE_STYLES = [{ label: 'Bold', style: 'BOLD' }, { label: 'Italic', style: 'ITALIC' }, { label: 'Underline', style: 'UNDERLINE' }, { label: 'Monospace', style: 'CODE' }];

var InlineStyleControls = function InlineStyleControls(props) {
	var currentStyle = props.editorState.getCurrentInlineStyle();
	return _react2['default'].createElement(
		'div',
		{ className: 'RichEditor-controls' },
		INLINE_STYLES.map(function (type) {
			return _react2['default'].createElement(StyleButton, {
				key: type.label,
				active: currentStyle.has(type.style),
				label: type.label,
				onToggle: props.onToggle,
				style: type.style
			});
		})
	);
};
module.exports = exports['default'];
/*<BlockStyleControls
editorState={editorState}
onToggle={this.toggleBlockType}
/>
*/