'use strict';

Object.defineProperty(exports, '__esModule', {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var TooltipStyle = {
	position: 'absolute',
	padding: '0 5px'
};
var TooltipInnerStyle = {
	padding: '3px 8px',
	color: '#fff',
	textAlign: 'center',
	borderRadius: 3,
	backgroundColor: '#000',
	opacity: .75
};
var TooltipArrowStyle = {
	position: 'absolute',
	width: 0, height: 0,
	borderRightColor: 'transparent',
	borderLeftColor: 'transparent',
	borderTopColor: 'transparent',
	borderBottomColor: 'transparent',
	borderStyle: 'solid',
	opacity: .75
};
var PlacementStyles = {
	left: {
		tooltip: { marginLeft: -3, padding: '0 5px' },
		arrow: {
			right: 0, marginTop: -5, borderWidth: '5px 0 5px 5px', borderLeftColor: '#000'
		}
	},
	right: {
		tooltip: { marginRight: 3, padding: '0 5px' },
		arrow: { left: 0, marginTop: -5, borderWidth: '5px 5px 5px 0', borderRightColor: '#000' }
	},
	top: {
		tooltip: { marginTop: -3, padding: '5px 0' },
		arrow: { bottom: 0, marginLeft: -5, borderWidth: '5px 5px 0', borderTopColor: '#000' }
	},
	bottom: {
		tooltip: { marginBottom: 3, padding: '5px 0' },
		arrow: { top: 0, marginLeft: -5, borderWidth: '0 5px 5px', borderBottomColor: '#000' }
	}
};

var ToolTip = (function (_React$Component) {
	_inherits(ToolTip, _React$Component);

	function ToolTip() {
		_classCallCheck(this, ToolTip);

		_get(Object.getPrototypeOf(ToolTip.prototype), 'constructor', this).apply(this, arguments);
	}

	_createClass(ToolTip, [{
		key: 'render',
		value: function render() {
			var placementStyle = PlacementStyles[this.props.placement];

			var _props = this.props;
			var style = _props.style;
			var _props$arrowOffsetLeft = _props.arrowOffsetLeft;
			var left = _props$arrowOffsetLeft === undefined ? placementStyle.arrow.left : _props$arrowOffsetLeft;
			var _props$arrowOffsetTop = _props.arrowOffsetTop;
			var top = _props$arrowOffsetTop === undefined ? placementStyle.arrow.top : _props$arrowOffsetTop;

			var props = _objectWithoutProperties(_props, ['style', 'arrowOffsetLeft', 'arrowOffsetTop']);

			return _react2['default'].createElement(
				'div',
				{ style: _extends({}, TooltipStyle, placementStyle.tooltip, style) },
				_react2['default'].createElement('div', { style: _extends({}, TooltipArrowStyle, placementStyle.arrow, { left: left, top: top }) }),
				_react2['default'].createElement(
					'div',
					{ style: TooltipInnerStyle },
					props.children
				)
			);
		}
	}]);

	return ToolTip;
})(_react2['default'].Component);

exports['default'] = ToolTip;
module.exports = exports['default'];